# # -*- coding: utf-8 -*-
#
#    copyright (C) 2023 Steffen Rolapp (github@rolapp.de)
#
#    based on ZattooBoxExtended by Daniel Griner (griner.ch@gmail.com) license under GPL
#
#    This file is part of ZattooHiQ
#
#    zattooHiQ is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    zattooHiQ is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with zattooHiQ.  If not, see <http://www.gnu.org/licenses/>.
#

import xbmc, xbmcgui, xbmcplugin, xbmcaddon, xbmcvfs
import sys, urllib.parse, os, json
import time, datetime, threading
import _strptime
import platform

from time import strftime, localtime
from urllib.parse import parse_qsl
#from .myplayer import myPlayer
from .zattooDB import ZattooDB
from .library import library
from .guiactions import *
from .keymap import KeyMap
from .helpmy import HelpGui
#from .vod import vod
#from .gui import zattooGUI
#from .gui import zattooOSD
#from .gui import *


__addon__       = xbmcaddon.Addon()
__addonId__     = __addon__.getAddonInfo('id')
__addonname__   = __addon__.getAddonInfo('name')
__addondir__    = xbmcvfs.translatePath( __addon__.getAddonInfo('profile') )
__addonuri__    = sys.argv[0] #'plugin://plugin.video.zattoo_hiq/'

_timezone_ = int(__addon__.getSetting('time_offset'))*60*-60 #-time.altzone
_umlaut_ = {ord('ä'): 'ae', ord('ö'): 'oe', ord('ü'): 'ue', ord('ß'): 'ss'}
localString = __addon__.getLocalizedString
local = xbmc.getLocalizedString
DEBUG = __addon__.getSetting('debug')
#player = myPlayer()

_channelList_=[]
_zattooDB_=ZattooDB()
_library_=library()
_keymap_=KeyMap()

player = None

#_keymap_.saveKeyMap()
_keymap_.toggleKeyMap()

### Account Data ###

#accountData=_zattooDB_.zapi.get_accountData()
#hiq = accountData['account']['permissions']
#accountData = _zattooDB_.zapi.exec_zapiCall('/zapi/v2/session', None)
# hiq = accountData['session']['user']['products']

# if hiq == []:
    # premiumUser = False
    # __addon__.setSetting('accounttype', 'Free')
# else:
    # premiumUser = True
    # __addon__.setSetting('accounttype', str(hiq[0]['name']))
    
if __addon__.getSetting('show_favourites') == 'true':
    xbmcgui.Window(10000).setProperty('favourites', 'true')
else:
    xbmcgui.Window(10000).setProperty('favourites', 'false')
    
accountData=_zattooDB_.zapi.get_accountData()
# Set Recall
try:
    if "recall_activated" in accountData['account']['permissions']  and accountData['nonlive']['replay_availability'] == 'available':
            RECALL = True
    else:
            RECALL = False
except:
    RECALL = False

# Set Restart
try:
    if "recall_eligible" in accountData['account']['permissions'] and accountData['nonlive']['replay_availability'] == 'available':
        RESTART = True
    else:
        RESTART = False
except:
    RESTART = False

# # Set Vod
# try:
    # if accountData['nonlive']["vod_eligible"]:
        # VOD = accountData['nonlive']["vod_eligible"]
    # else:
        # VOD = False
# except:
    # VOD = False

# Set Settings Info
if accountData['nonlive']['replay_availability'] == 'available':
    __addon__.setSetting('recall', localString(310032))
    __addon__.setSetting('recall_bool', 'true')
elif accountData['nonlive']['replay_availability'] == 'needs_activation':
    __addon__.setSetting('recall', localString(310036))
    __addon__.setSetting('recall_bool', 'false')
else:
    __addon__.setSetting('recall', localString(310039))
    __addon__.setSetting('recall_bool', 'false')

# Set Youth Protection PIN
try:
    params = {'password': __addon__.getSetting('password')}
    req = _zattooDB_.zapi.exec_zapiCall('/zapi/account/get_pin', params)
    YPIN = req['pin']
    __addon__.setSetting('ypin', YPIN)
except:
    YPIN = __addon__.getSetting('ypin')

if len(YPIN) != 4:
    xbmcgui.Dialog().ok(__addonname__, localString(31927))
    __addon__.openSettings()

# pin = _zattooDB_.zapi.exec_zapiCall('/zapi/account/pin_toggle', None)


try:
  SERIE=accountData['nonlive']['series_recording_eligible']
except KeyError:SERIE = False

# try:
    # if accountData['nonlive']['recording_number_limit'] > 0:
        # RECORD = True
        # resultData = _zattooDB_.zapi.exec_zapiCall('/zapi/playlist', None)
        # RecCount = len(resultData['recordings'])
        # __addon__.setSetting('record', str(RecCount) + '/' + str(accountData['nonlive']['recording_number_limit']))
# except KeyError:
    # RECORD = False
    # __addon__.setSetting('record', localString(310039))

try:
  country=accountData['account']['service_country']
  __addon__.setSetting('country', country)
except: pass


if __addon__.getSetting('country') == 'CH': SWISS = True
else: SWISS = False

## Images ##
ICON_IMG = __addon__.getAddonInfo('path') + '/resources/icon.png'
FANART_IMG = __addon__.getAddonInfo('path') + 'resources/fanart.jpg'
LIST_IMG = __addon__.getAddonInfo('path') + '/resources/media/list.png'
HELP_IMG = __addon__.getAddonInfo('path') + '/resources/media/help.png'
SETTING_IMG = __addon__.getAddonInfo('path') + '/resources/media/setting.png'
RECORD_IMG = __addon__.getAddonInfo('path') + '/resources/media/record.png'
POPULAR_IMG = __addon__.getAddonInfo('path') + '/resources/media/popular.png'
SEARCH_IMG = __addon__.getAddonInfo('path') + '/resources/media/search.png'
VOD_IMG = __addon__.getAddonInfo('path') + '/resources/media/vod.png'
PREVIEW_IMG = __addon__.getAddonInfo('path') + '/resources/media/preview.png'
EPG_IMG = __addon__.getAddonInfo('path') + '/resources/media/epg.png'
KAT_IMG = __addon__.getAddonInfo('path') + '/resources/media/kat.png'

#stream_type = __addon__.getSetting('stream_type')
RECREADY = __addon__.getSetting('rec_ready')
RECNOW = __addon__.getSetting('rec_now')
VERSION = __addon__.getAddonInfo('version')
DOLBY = __addon__.getSetting('dolby')
#KEYMAP = __addon__.getSetting('keymap')
PLAYLIST = xbmc.PlayList(xbmc.PLAYLIST_VIDEO)

# if premiumUser or SWISS:
  # xbmc.executebuiltin( "Skin.SetBool(%s)" %'record')
# else:
  # xbmc.executebuiltin( "Skin.Reset(%s)" %'record')

if RECALL:
  xbmc.executebuiltin( "Skin.SetBool(%s)" %'restart')
else:
  xbmc.executebuiltin( "Skin.Reset(%s)" %'restart')
    
def debug(content):
    if DEBUG:log(content, xbmc.LOGDEBUG)

def notice(content):
    log(content, xbmc.LOGINFO)

def log(msg, level=xbmc.LOGINFO):
    addon = xbmcaddon.Addon()
    addonID = addon.getAddonInfo('id')
    xbmc.log('%s: %s' % (addonID, msg), level)

def convert_date(date):
    debug(date)
    try:
        res = datetime.datetime.strptime(date, "%Y-%m-%dT%H:%M:%SZ")
    except TypeError:
        res = datetime.datetime(*(time.strptime(date, "%Y-%m-%dT%H:%M:%SZ")[0:6]))
    res += datetime.timedelta(seconds=_timezone_)
    return str(res.strftime('%A,%d.%B %Y %H:%M'))
    
def convert_date(date):
    debug(date)
    try:
        res = datetime.datetime.strptime(date, "%Y-%m-%dT%H:%M:%SZ")
    except TypeError:
        res = datetime.datetime(*(time.strptime(date, "%Y-%m-%dT%H:%M:%SZ")[0:6]))
    res += datetime.timedelta(seconds=_timezone_)
    return str(res.strftime('%A,%d.%B %Y %H:%M'))

def formatTime(timestamp):
    if timestamp:
        format = xbmc.getRegion('time').replace(':%S', '').replace('%H%H', '%H')
        return timestamp.strftime(format)
    else:
        return ''
  
def formatDate(timestamp, format):
    if timestamp:
        date = timestamp.strftime(format)
        date = date.replace('Monday', local(11))
        date = date.replace('Tuesday', local(12))
        date = date.replace('Wednesday', local(13))
        date = date.replace('Thursday', local(14))
        date = date.replace('Friday', local(15))
        date = date.replace('Saturday', local(16))
        date = date.replace('Sunday', local(17))
        date = date.replace('January', local(21))
        date = date.replace('February', local(22))
        date = date.replace('March', local(23))
        date = date.replace('April', local(24))
        date = date.replace('May', local(25))
        date = date.replace('June', local(26))
        date = date.replace('July', local(27))
        date = date.replace('August', local(28))
        date = date.replace('September', local(29))
        date = date.replace('October', local(30))
        date = date.replace('November', local(31))
        date = date.replace('December', local(32))
        return date
    else:
        return ''

def set_player(myplayer):
    global player
    player = myplayer
    
def to_seconds(date):
    return time.mktime(date.timetuple())

def showEpg():
    xbmc.executebuiltin("Dialog.Close(all, true)")
    xbmcgui.Window(10000).setProperty('zattoo_runningView','epg')
    from .epg import EPG
    _listMode_ = get_listmode()
    currentChannel = _zattooDB_.get_playing()['channel']
    channelList = _zattooDB_.getChannelList(_listMode_ == 'favourites')
    #debug(str(channelList))
    try:
        currentNr=channelList[currentChannel]['nr']
    except:
        currentNr=0
  
    epg = EPG(currentNr)
    epg.loadChannels(_listMode_ == 'favourites')
    #epg.show() 
    epg.doModal()
    #while xbmcgui.Window(10000).getProperty('zattoo_runningView')=="epg": xbmc.sleep(200)
    del epg

def showHelp(Img):
    gui = HelpGui(Img)
    gui.showHelp(Img)
    gui.doModal()
    del gui
    
# def watch_channel(channel_id, start, end, showID="", recall='false', add='false'):
    # global player
    # #_keymap_.toggleKeyMap()
    # _zattooDB_=ZattooDB()
    
    # #selected currently playing live TV
    # playing = _zattooDB_.get_playing()
    # xbmcgui.Window(10000).setProperty('lastChannel', playing['channel'])

    # pre = __addon__.getSetting('pre_padding')
    # post = __addon__.getSetting('post_padding')
    # drm = _zattooDB_.get_drm(channel_id)
  
    # if recall == 'true':
        # debug(recall)
        # params = {'enable_eac3':DOLBY, 'pre_padding':pre, 'post_padding':post, 'youth_protection_pin': YPIN}
        # if drm: 
            # params['stream_type'] = 'dash_widevine'
            # params['max_drm_lvl'] = '3'
            # if SWISS:
                # debug('swiss')
                # if platform.system() == 'Linux':
                    # #params['quality'] = 'sd'
                    # params['stream_type'] = 'dash'
        # else:
            # params['stream_type'] = 'dash'
        # resultData = _zattooDB_.zapi.exec_zapiCall('/zapi/v3/watch/replay/' + channel_id + '/' + showID, params)

        # if resultData is None:
            # #if add == 'true': return
            # xbmcgui.Dialog().notification("ERROR", "NO ZAPI RESULT", channelInfo['logo'], 5000, False)
            # return  
        # streams = resultData['stream']['watch_urls']
        # if len(streams)==0:
            # xbmcgui.Dialog().notification("ERROR", "NO STREAM FOUND, CHECK SETTINGS!", channelInfo['logo'], 5000, False)
            # return
        # # change stream if settings are set
        # elif len(streams) > 1 and  __addon__.getSetting('audio_stream') == 'B' and streams[1]['audio_channel'] == 'B': streamNr = 1
        # else:  streamNr = 0
        # url = streams[streamNr]['url']
    # else:
        # data = _zattooDB_.get_streams(channel_id) 
        # streams = data['streams']
        # url = data['url']
        # key =data['key']
    # # save currently playing
    # if showID == '1':
        # prog = _zattooDB_.getPrograms({'index':[channel_id]})
        # showID = prog[0]['showID']
    # program = _zattooDB_.get_showID(showID)
    # showinfo = _zattooDB_.getShowInfo(showID)
    # channelInfo = _zattooDB_.get_channelInfo(channel_id)
        
    # listitem = xbmcgui.ListItem(path=url)      
    # if program:
        # program = program[0]
        # heading = ('[B]' + channelInfo['title'] + '[/B] ').translate(_umlaut_) + '  ' + program['start_date'].strftime('%H:%M') + '-' + program['end_date'].strftime('%H:%M')
        # xbmcgui.Dialog().notification(heading, program['title'].translate(_umlaut_), channelInfo['logo'], 5000, False)
    
        # #set info for recall
        # vinfo = listitem.getVideoInfoTag()
        # vinfo.setTvShowTitle(channelInfo['title'])# + ', ' + formatDate(program['start_date'],strftime('%A %H:%M') + '-' + program['end_date'],strftime('%H:%M')))
        # vinfo.setTitle(program['title'])
        # #vinfo.setResumePoint(0, program['duration'])
        # vinfo.setPath(url)
        # vinfo.setUniqueIDs({'tvdb':channel_id, 'imdb':showID})
        # #meta = { 'title': prog['title'], 'episode': streamNr, 'tvshowtitle': channelInfo['title']+ ', ' + formatDate(prog['start_date'],'%A %H:%M') + '-' + prog['end_date'].strftime('%H:%M'), 'premiered' :'premiered', 'duration' : '20', 'rating': 'rating', 'director': 'director', 'writer': 'writer', 'plot': program['description_long']}
        # #listitem.setInfo("Video", meta)
        # listitem.setLabel(program['title'] + ' - ' + str(program['description']))
        # listitem.setArt({ 'icon': channelInfo['logo'], 'poster': channelInfo['logo'], 'clearlogo' : channelInfo['logo'], 'thumb': channelInfo['logo']})
        # listitem.setInfo('Video',{'director': channel_id, 'writer': showID})
    
    # if drm:
        # listitem.setProperty('inputstream', 'inputstream.adaptive')
        # listitem.setProperty('inputstream.adaptive.manifest_type', 'mpd')
        # listitem.setProperty('inputstream.adaptive.license_key', key + "||a{SSM}|")
        # listitem.setProperty('inputstream.adaptive.license_type', "com.widevine.alpha")
    
    # else:
        # listitem.setProperty('inputstream', 'inputstream.adaptive')
        # listitem.setProperty('inputstream.adaptive.manifest_type', 'mpd')
        
    # listitem.setProperty('isplayable', 'true')
    # listitem.setIsFolder(False)
      
    # xbmcplugin.setResolvedUrl(__addonhandle__, True, listitem)
  
    # #play liveTV: info is created in OSD
    # # set add to playlist
    # afterRecall = __addon__.getSetting('after_recall')
    # xbmcgui.Window(12005).setProperty('after_recall', afterRecall)
  
    # #play liveTV: info is created in OSD
    # # GreenAir: play live stream or recall without PLAYLIST

    # if recall=='false' or afterRecall != '3':
      # player.PlayStream(url, listitem)
      # #th = threading.Thread(target=container_refresh)
      # #th.start()
      # #makeZattooGUI()
      

    # else:
        # PLAYLIST.add(url=streams[streamNr]['url'], listitem=listitem)
        # # GreenAir: start playing PLAYLIST if this is the first entry
        # if PLAYLIST.size()==1:
            # player.PlayStream(PLAYLIST)
            # #GreenAir: don't block execution, showToggleImg() has to create zattooPiP on return
            # #while player.isPlaying():xbmc.sleep(100)

# def container_refresh():
    # monitor = xbmc.Monitor()
    # while not monitor.abortRequested():
        # if monitor.waitForAbort(300): break
        # xbmc.executebuiltin('Container.Refresh')    
        
# def watch_recording(recording_id, cid, start=0):
  # #if xbmc.Player().isPlaying(): return

  # if start == 0:
    # startTime=int(xbmc.getInfoLabel('ListItem.Property(zStartTime)'))

  # else:
    # startTime=int(start)

  # # drm = _zattooDB_.get_drm(cid)
  # # if drm:
      # # stream_type = 'dash_widevine'
  # # else:
  # stream_type = 'dash'
  # params = {'stream_type': stream_type, 'enable_eac3':DOLBY, 'youth_protection_pin': YPIN}
  # resultData = _zattooDB_.zapi.exec_zapiCall('/zapi/watch/recording/' + recording_id, params)
  # debug ('ResultData: '+str(resultData))
  # if resultData is not None:
    # streams = resultData['stream']['watch_urls']

    # li = xbmcgui.ListItem(path=streams[0]['url'])

    # if stream_type == 'dash':
        # li.setProperty('inputstream', 'inputstream.adaptive')
        # li.setProperty('inputstream.adaptive.manifest_type', 'mpd')

    # elif stream_type == 'dash_widevine':
        # li.setProperty('inputstream', 'inputstream.adaptive')
        # li.setProperty('inputstream.adaptive.manifest_type', 'mpd')
        # li.setProperty('inputstream.adaptive.license_type', "com.widevine.alpha")
# #        li.setProperty('inputstream.adaptive.stream_headers', 'xUser-Agent=Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:109.0) Gecko/20100101 Firefox/109.0')
        # li.setProperty('inputstream.adaptive.license_key', streams[1]['license_url'] + "||a{SSM}|")

    # xbmcplugin.setResolvedUrl(__addonhandle__, True, li)
    # pos=0
    # xbmc.sleep(200)
    # player=xbmc.Player()
    # while (player.isPlaying()):
        # try: pos=player.getTime()
        # except: pass
        # xbmc.sleep(100)

    # #send watched position to zattoo
    # #zStoptime=datetime.datetime.fromtimestamp(startTime+round(pos)-300).strftime("%Y-%m-%dT%H:%M:%SZ")

    # zStoptime=datetime.datetime.fromtimestamp(startTime+round(pos)-300 - _timezone_ ).strftime("%Y-%m-%dT%H:%M:%SZ")
    # resultData = _zattooDB_.zapi.exec_zapiCall('/zapi/playlist/recording', {'recording_id': recording_id, 'position': zStoptime})
    # xbmc.executebuiltin('Container.Refresh')
    # debug(resultData)

def setup_recording(program_id):
  #print('RECORDING: '+program_id)
  params = {'program_id': program_id}
  # test ob Aufnahme existiert
  playlist = _zattooDB_.zapi.exec_zapiCall('/zapi/playlist', None)
  for record in playlist['recordings']:
      if int(params['program_id']) == int(record['program_id']):
          xbmcgui.Dialog().ok(__addonname__, __addon__.getLocalizedString(31906))
          return

  resultData = _zattooDB_.zapi.exec_zapiCall('/zapi/playlist/program', params)

  debug('Recording: '+str(params)+'  '+str(resultData))

  if resultData is not None:
    xbmcgui.Dialog().ok(__addonname__, __addon__.getLocalizedString(31903) + '\n'+ __addon__.getLocalizedString(31904))
    Data = _zattooDB_.zapi.exec_zapiCall('/zapi/playlist', None)
    RecCount = len(Data['recordings'])
    __addon__.setSetting('record', str(RecCount) + '/' + str(accountData['nonlive']['recording_number_limit']))
  else:
    xbmcgui.Dialog().ok(__addonname__, __addon__.getLocalizedString(31905))

  _library_.make_library()  # NEW added - by Samoth


def delete_recording(recording_id, title):
  dialog = xbmcgui.Dialog()
  ret = dialog.yesno(local(19112), str(title) + "\n" + '[COLOR gold]' + localString(32025)+'[/COLOR]' + '\n' + localString(32026) + '\n \n'+'[COLOR red]'+local(19291)+'[/COLOR]')
  if ret ==1:
    params = {'recording_id': recording_id}
    folder=__addon__.getSetting('library_dir') # NEW added - by Samoth
    if folder: # NEW added - by Samoth
      _library_.delete_entry_from_library(str(recording_id)) # NEW added - by Samoth
    resultData = _zattooDB_.zapi.exec_zapiCall('/zapi/playlist/remove', params)
    Data = _zattooDB_.zapi.exec_zapiCall('/zapi/playlist', None)
    RecCount = len(Data['recordings'])
    __addon__.setSetting('record', str(RecCount) + '/' + str(accountData['nonlive']['recording_number_limit']))
    xbmc.executebuiltin('Container.Refresh')

def delete_series(recording_id, series):
  dialog = xbmcgui.Dialog()
  params = {'recording_id': recording_id, 'tv_series_id':series, 'remove_recording':'true'}
  folder=__addon__.getSetting('library_dir') # NEW added - by Samoth
  if folder: # NEW added - by Samoth
    _library_.delete_entry_from_library(str(recording_id)) # NEW added - by Samoth
  resultData = _zattooDB_.zapi.exec_zapiCall('/zapi/series_recording/remove', params)
  xbmc.executebuiltin('Container.Refresh')
  Data = _zattooDB_.zapi.exec_zapiCall('/zapi/playlist', None)
  RecCount = len(Data['recordings'])
  __addon__.setSetting('record', str(RecCount) + '/' + str(accountData['nonlive']['recording_number_limit']))

def slugify(value):
    """
    Normalizes string, converts to lowercase, removes non-alpha characters,
    and converts spaces to hyphens.
    """
    import re, unicodedata
    value = unicodedata.normalize('NFKD', value).encode('ascii', 'ignore')
    value = str(re.sub('[^\w\s-]', '', value).strip().lower())
    value = str(re.sub('[-\s]+', '-', value))
    return value

def showPreview(popularList=''):
  xbmc.executebuiltin("Dialog.Close(all, true)")
  _listMode_ = get_listmode()
  from .channelspreview import ChannelsPreview
  preview = ChannelsPreview()
  if popularList=='popular': preview.createPreview('popular')
  else: preview.createPreview(_listMode_ == 'favourites')
  preview.show() #doModal()
  while xbmcgui.Window(10000).getProperty('zattoo_runningView')=="preview": xbmc.sleep(10)
  del preview

def selectStartChannel():
  _listMode_ = get_listmode()
  channels = _zattooDB_.getChannelList(_listMode_ == 'favourites')
  chanList = [localString(310095)]
  for chan in channels['index']: chanList.append(channels[chan]['title'])
  dialog=xbmcgui.Dialog()
  ret = dialog.select(localString(31009), chanList)
  if ret==-1: return
  __addon__.setSetting('start_liveTV', 'true')
  if ret==0: __addon__.setSetting('start_channel', 'lastChannel')
  else: __addon__.setSetting('start_channel', chanList[ret])

def get_listmode():
  debug(xbmcgui.Window(10000).getProperty('favourites'))
  if xbmcgui.Window(10000).getProperty('favourites') == 'true':
    listMode = 'favourites'
  else:
    listMode = 'all'
  return listMode


    

    


